Cognitive Interaction Toolkit - Bug #226

Please make the Jenkins installer use a _STATIC_ package
2014-04-07 11:50 - Florian Lier

Status: Closed Start date: 2014-04-07
Priority: Immediate Due date:

Assignee: Johannes Wienke % Done: 100%
Category: Recipe Estimated time: 0.00 hour
Target version: Toolkit 0.1 Spent time: 9.66 hours
Description

Today | wanted to convince a colleague to make use of the new tool chain, aka toolkit-distribution using recipes via local Jenkins,
instead of the Gar-Installer (which my colleague is used to and which he really likes) to distribute his components. After explaining
him the advantages of the "new" approach he was willing to try it.

BUT

Again, the Jenkins bootstrapping failed because some plugins couldn't be fetched (Git, Build-Flow), which | only found out by
checking the Jenkins config via Jenkins GUI. Comment of the the colleague:

"Okay, at this point | would already be lost..."

Additionally, somehow Jenkins is not able to find the Plugin repository (Jenkins version is: Jenkins ver. 1.532.2) so | really wasn't
able to create all Jobs because the build-generator fails, again, because Jenkins was not setup correctly.

IMHO this is basically A SHOW STOPPER we will not be able to convince people to use our new tool chain (I am fully convinced it's
the right way to go) if the setup already fails, especially because Jenkins is such a central component.

| really don't blame the implementation/developer of the installer script, dynamic web-based fetching of plugins is simply
a "fragile" thing.

I would like to vote for a hosted tar.gz file including all the required plugins and Jenkins itself.

Any comments?

Associated revisions

Revision 32e6988c - 2014-04-08 13:53 - Johannes Wienke

Configure update site correctly

Despite using the LTS update site for first plugin installation, the one
configured inside jenkins was still pointing to the trunk plugins. This
commit also configures the URL for the LTS plugins.

refs #226

Revision ¢505d586 - 2014-04-08 14:03 - Johannes Wienke

Make installed folder relocatable
Removed the absolute location from the starter script.

refs #226

2025-07-09 1/5




Revision 93c6ff9f - 2014-04-08 15:20 - Johannes Wienke

Fail in case a plugin could not be installed

In some cases the jenkins CLI does not indicate an error if a plugin
could not be installed. In order to still catch those error, actively
check for the each new plugin being installed.

refs #226

Revision 62b11158 - 2014-04-08 16:05 - Johannes Wienke

Fix job generator symlink
Use a relative path to be relocatable

refs #226

Revision 57b9cc74 - 2014-04-08 16:31 - Johannes Wienke

Do not block in case jenkins does not start

refs #226

Revision ef6e09f7 - 2014-04-11 14:43 - Johannes Wienke

Fix plugin verification step

Some plugins were only available after a restart of jenkins. However,
the verification process was performed immediately after installing.
This was a race condition. A restart was added.

refs #226

History

#1 - 2014-04-07 11:54 - Florian Lier

- Description updated

#2 - 2014-04-07 11:59 - Arne Nordmann

- Status changed from New to Feedback

| kind of agree, this still feels fragile (well, it is some kind of prototype). | managed to use by just re-doing it one or two times and then the plugin
installation went well. At some point | installed the required plugins by myself ... but | agree, this is not very usable and a showstopper.

So if we could go for a archive with the latest Jenkins LTS and stable versions of the plugins, that would be very nice. | like the idea.

#3 - 2014-04-07 12:07 - Florian Lier
- File jenkins_failed_download.png added

This is exactly the problem (see attached image).

Thank you for your comment Arne!

#4 - 2014-04-07 12:08 - Jan Moringen

Same thing happened during LSP-CSRA code sprint. In that case, the error seemed more permanent and plugins had to be manually copied from a
previous Jenkins installation.

#5 - 2014-04-08 11:10 - Johannes Wienke
- Status changed from Feedback to In Progress

- Assignee changed from Florian Lier to Johannes Wienke

I will try to fix some things so that we can build a jenkins job from this.

#6 - 2014-04-08 11:13 - Florian Lier

...do you think this will solve the problem? | mean, if the job is red, because some plugin couldn't be fetched, that won't help when you really need it,
e.g., when introducing the tool to someone.

Maybe | didn't get your point.

#7 - 2014-04-08 11:21 - Johannes Wienke

The job may fail sometimes, still the last valid archive will be preserved by jenkins. | think that's better than nothing.

#8 - 2014-04-08 11:22 - Florian Lier

... think that's a nice option.

#9 - 2014-04-08 16:10 - Johannes Wienke

Wooooaaa, | can't even really test this because the jenkins web infrastructure is soo brittle.

#10 - 2014-04-08 16:44 - Florian Lier

;) Welcome to my world

#11 - 2014-04-08 16:55 - Johannes Wienke

| can't finish this today. Someone from the jenkins team has to fix the infrastructure first.

#12 - 2014-04-08 20:34 - Florian Lier

| just pulled recent changes, | like the new messages, feels a lot better to actually see what's going on, | also like the Security Warning.

#13 - 2014-04-08 20:40 - Johannes Wienke

That means the installation succeeded? | never managed to get there ;)

#14 - 2014-04-08 20:43 - Florian Lier

Yes, so far the installation worked, | am currently adding jobs via generator. The only question | have in mind is: If you enable security, meaning you
need to login, is the build generator still able to add jobs?
#15 - 2014-04-08 20:45 - Jan Moringen

The build-generator can authenticate. See output of --help.

#16 - 2014-04-08 20:48 - Florian Lier

Yeah, that's great. We need to document that | guess. Does the Drupal Auth also work? How did you manage ;) Because | the documentation is not
very clear on that one.

#17 - 2014-04-08 20:59 - Florian Lier

Job Generation worked! Good "Job" Johannes :)

#18 - 2014-04-11 14:52 - Johannes Wienke
- % Done changed from 0 to 90

A jenkins jobs is now available and installation has been fixed as much as possible. Can someone please test the archive before | add a description
to the wiki page:
https://ci.toolkit.cit-ec.de/job/jenkins-distribution/

#19 - 2014-04-11 15:02 - Sebastian Wrede

Nice. Does the static package already get pushed to some publicly available location?

https:/ci.toolkit.cit-ec.de/job/jenkins-distribution/ is not available from outside of the university network (IIRC) or is otherwise currently not available
(also not when connecting via VPN).

#20 - 2014-04-11 15:17 - Johannes Wienke

It wasn't even really tested so far and | don't have a location. ;)

#21 - 2014-04-25 11:44 - Johannes Wienke

So where should this be uploaded? Seems to be working now.

#22 - 2014-05-08 13:25 - Florian Lier

ci.toolkit is not the best idea since it can't be accessed from everywhere (i.e. externals)

#23 - 2014-05-08 13:31 - Sebastian Wrede

What about pushing it to the toolkit web server (toolkit.cit-ec.”)?

#24 - 2014-05-08 13:38 - Florian Lier

| could add an account on the toolkit (toolkit.cit-ec) machine that has limited rights, configure a section in the web server cfg and add a "copy via ssh"
build step in the job that creates the *.tar.gz

If there is no veto, I'd like to go with this.

#25 - 2014-05-08 13:39 - Johannes Wienke

Sounds ok to me.

#26 - 2014-05-08 15:02 - Florian Lier

Now, the Cl generated *tar.gz is scp'ed on the toolkit machine and available via:
https://ci.toolkit.cit-ec.de/job/jenkins-distribution/
https://ci.toolkit.cit-ec.de/job/jenkins-distribution/

https://toolkit.cit-ec.uni-bielefeld.de/dist/jenkins.tar.gz

#27 - 2014-05-09 14:23 - Florian Lier
- Status changed from In Progress to Closed

- % Done changed from 90 to 100

The file is avail under: https:/toalkit.cit-ec.uni-bielefeld.de/dist/jenkins.tar.gz
